<template>
  <div>
    <v-row justify="center">
      <v-col md="12">
        <div class="title text-center">Estados de los documentos</div>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="12">
        <div class="text-center">Selecciona la fecha de visualización</div>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="3">
        <div class="subtitle-2">
          <strong>Fecha de inicio</strong>
        </div>
        <v-menu
          v-model="menuFechaInicio"
          :close-on-content-click="false"
          transition="scale-transition"
          offset-y
          max-width="290px"
          min-width="auto"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="dateStartFormatted"
              readonly
              append-icon="mdi-calendar"
              v-bind="attrs"
              v-on="on"
            ></v-text-field>
          </template>
          <v-date-picker
            v-model="fechaInicio"
            no-title
            color="primary"
            @input="menuFechaInicio = false"
          ></v-date-picker>
        </v-menu>
      </v-col>
      <v-col md="3">
        <div class="subtitle-2">
          <strong>Fecha fin</strong>
        </div>
        <v-menu
          v-model="menuFechaFin"
          :close-on-content-click="false"
          transition="scale-transition"
          offset-y
          max-width="290px"
          min-width="auto"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="dateEndFormatted"
              readonly
              append-icon="mdi-calendar"
              v-bind="attrs"
              v-on="on"
            ></v-text-field>
          </template>
          <v-date-picker
            v-model="fechaFin"
            color="primary"
            no-title
            @input="menuFechaFin = false"
          ></v-date-picker>
        </v-menu>
      </v-col>
      <v-col md="1 pt-11">
        <v-btn bottom block color="primary" @click="getFoliosEstadosBusquedas"
          >Filtrar</v-btn
        >
      </v-col>
    </v-row>
    <div class="gris">
      <v-data-table
        :headers="headers"
        :items="data"
        :page.sync="page"
        :items-per-page="itemsPerPage"
        item-key="idFolio"
        :loading="loading"
        :height="350"
        :dense="true"
        :fixed-header="true"
        show-select
        class="custom-table"
        @page-count="pageCount = $event"
        hide-default-footer
        @input="selectedItems"
      >
        <template v-slot:item.documento.titulo="{ item }" }>
          <router-link class="link" :to="to(item)">
            {{ item.documento.titulo }}
          </router-link>
        </template>
        <template v-slot:item.unidadesNegocio="{ item }" }>
          <template v-if="item.unidadesNegocio.length > 0">
            <template v-if="item.unidadesNegocio.length == 1">
              {{ item.unidadesNegocio[0].descripcion }}
            </template>
            <template v-else>
              <div class="mt-2" style="display: inline-block">
                {{ item.unidadesNegocio[0].descripcion }}
              </div>
              <v-menu bottom left>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn
                    class="float-rigth"
                    right
                    fab
                    dark
                    x-small
                    dense
                    :elevation="0"
                    color="grey"
                    v-bind="attrs"
                    v-on="on"
                  >
                    <v-icon>mdi-dots-vertical</v-icon>
                  </v-btn>
                </template>
                <v-list>
                  <template
                    v-for="(itemUnidadNegocio, i) in item.unidadesNegocio"
                  >
                    <v-list-item v-if="i > 0" :key="i">
                      <v-list-item-title>{{
                        itemUnidadNegocio.descripcion
                      }}</v-list-item-title>
                    </v-list-item>
                  </template>
                </v-list>
              </v-menu>
            </template>
          </template>
          <template v-else>
            <span class="text--disabled">N/A</span>
          </template>
        </template>
        <template v-slot:item.estado.descripcion="{ item }" }>
          <span :class="classEstado(item.estado.idEstadoFolio)">{{
            item.estado.descripcion
          }}</span>
        </template>
        <template v-slot:item.firmas.ultima.nombre="{ item }" }>
          <template v-if="item.firmas.ultima.nombre">
            {{ item.firmas.ultima.nombre }}
          </template>
          <template v-else>
            <span class="text--disabled">N/A</span>
          </template>
        </template>
        <template v-slot:item.firmas.pendientes="{ item }" }>
          <template v-if="item.firmas.pendientes.length > 0">
            <template v-if="item.firmas.pendientes.length == 1">
              {{ item.firmas.pendientes[0].empleado.nombre }}
            </template>
            <template v-else>
              <div class="mt-2" style="display: inline-block">
                {{ item.firmas.pendientes[0].empleado.nombre }}
              </div>
              <v-menu bottom left>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn
                    class="float-rigth"
                    right
                    fab
                    dark
                    x-small
                    dense
                    :elevation="0"
                    color="grey"
                    v-bind="attrs"
                    v-on="on"
                  >
                    <v-icon>mdi-dots-vertical</v-icon>
                  </v-btn>
                </template>
                <v-list>
                  <template v-for="(itemFirma, i) in item.firmas.pendientes">
                    <v-list-item v-if="i > 0" :key="i">
                      <v-list-item-title>{{
                        itemFirma.empleado.nombre
                      }}</v-list-item-title>
                    </v-list-item>
                  </template>
                </v-list>
              </v-menu>
            </template>
          </template>
          <template v-else>
            <span class="text--disabled">N/A</span>
          </template>
        </template>
        <template v-slot:item.acciones="{ item }" }>
          <template>
            <v-speed-dial
              v-model="item.fab"
              direction="left"
              :left="true"
              transition="scale"
              class="custom-speed-dial"
            >
              <template v-slot:activator>
                <v-btn right icon v-model="item.fab">
                  <v-icon v-if="item.fab"> mdi-close </v-icon>
                  <v-icon v-else> mdi-reply-outline </v-icon>
                </v-btn>
              </template>
              <v-card :width="200">
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      v-if="
                        item.estado.idEstadoFolio == 2 ||
                        item.estado.idEstadoFolio == 3 ||
                        item.estado.idEstadoFolio == 4 ||
                        item.estado.idEstadoFolio == 5
                      "
                      class="ma-1"
                      color="#C0ABDD"
                      fab
                      x-small
                      dark
                      :to="editarRutasFolio(item)"
                    >
                      <v-icon>mdi-sitemap</v-icon>
                    </v-btn>
                  </template>
                  <span>Modificar rutas</span>
                </v-tooltip>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      v-if="item.estado.idEstadoFolio == 2"
                      class="ma-1"
                      color="#D6A6D2"
                      fab
                      x-small
                      dark
                      @click="putFolioEstados(item, 3)"
                    >
                      <v-icon>mdi-check-underline-circle-outline</v-icon>
                    </v-btn>
                  </template>
                  <span>Enviar a revisión</span>
                </v-tooltip>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      v-if="item.estado.idEstadoFolio == 5"
                      class="ma-1"
                      color="#D6EABB"
                      fab
                      x-small
                      dark
                      @click="putFolioDuplicar(item)"
                    >
                      <v-icon>mdi-file-document-multiple</v-icon>
                    </v-btn>
                  </template>
                  <span>Duplicar</span>
                </v-tooltip>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      v-if="item.estado.idEstadoFolio == 2"
                      class="ma-1"
                      color="#90EADF"
                      fab
                      x-small
                      dark
                      :to="editarFolio(item)"
                    >
                      <v-icon>mdi-pencil-outline</v-icon>
                    </v-btn>
                  </template>
                  <span>Editar</span>
                </v-tooltip>

                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      v-if="
                        (item.estado.idEstadoFolio == 3 ||
                          item.estado.idEstadoFolio == 4 ||
                          item.estado.idEstadoFolio == 5) &&
                        perfil
                      "
                      class="ma-1"
                      color="#DA3A2E"
                      fab
                      x-small
                      dark
                      @click="putFolioEstados(item, 2)"
                    >
                      <v-icon>mdi-pencil-outline</v-icon>
                    </v-btn>
                  </template>
                  <span>Bajar a modificación</span>
                </v-tooltip>

                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      v-if="
                        item.estado.idEstadoFolio == 2 ||
                        item.estado.idEstadoFolio == 3 ||
                        item.estado.idEstadoFolio == 4
                      "
                      class="ma-1"
                      color="#DA3A2E"
                      fab
                      x-small
                      dark
                      @click="deleteFolio(item)"
                    >
                      <v-icon>mdi-close-circle-outline</v-icon>
                    </v-btn>
                  </template>
                  <span>Borrar</span>
                </v-tooltip>
              </v-card>
            </v-speed-dial>
          </template>
        </template>
        <template v-slot:footer="{ props }">
          <div
            v-if="data.length > 0"
            class="pa-2 t-footer"
            style="height: 60px"
          >
            <div style="float: left">
              Se muestra del {{ props.pagination.pageStart + 1 }} al
              {{ props.pagination.pageStop }} de un total de
              {{ props.pagination.itemsLength }}
            </div>
            <v-pagination
              style="float: right"
              v-model="page"
              :length="props.pagination.pageCount"
              :total-visible="props.pagination.itemsPerPage"
            ></v-pagination>
          </div>
        </template>
      </v-data-table>
    </div>
    <v-row justify="center">
      <v-col md="3">
        <v-btn
          block
          color="secondary"
          :disabled="dataSelected.length == 0"
          @click="exportToExcel(dataSelectedToExport)"
          >Exportar seleccionado</v-btn
        >
      </v-col>
      <v-col md="3">
        <v-btn
          block
          color="primary"
          :disabled="data.length == 0"
          @click="exportToExcel(dataToExport)"
          >Exportar todo</v-btn
        >
      </v-col>
    </v-row>
    <template>
      <v-dialog v-model="dialogNewDocumento" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>El documento ha sido duplicado</strong>
              <v-btn
                color="secondary"
                icon
                dark
                @click="dialogNewDocumento = false"
                style="position: absolute; right: 0px; top: 0px"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-text>
            <span
              >Documento generado con
              <strong>Folio {{ idFolioCloned }}</strong>
            </span>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogNewDocumento = false"
                >Entiendo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.custom-speed-dial.v-speed-dial--direction-left .v-speed-dial__list {
  right: 60%;
}
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}

div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}

div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import moment from "moment";
import store from "@/store";
import FileSaver from "file-saver";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
const excelPlantilla = {
  nombre: "Folios",
  hojas: [
    {
      descripcion: "Hoja de folios",
      contenido: {
        cabezeras: [
          {
            valor: "idFolio",
            descripcion: "Folio",
          },
          {
            valor: "documento.titulo",
            descripcion: "Documento",
          },
          {
            valor: "unidadesNegocio",
            descripcion: "Unidad(es) de Negocio",
          },
          {
            valor: "creador.nombre",
            descripcion: "Documentador",
          },
          {
            valor: "estado.descripcion",
            descripcion: "Estado",
          },
          {
            valor: "firmas.ultima.empleado.nombre",
            descripcion: "Última Firma",
          },
          {
            valor: "firmas.pendientes",
            descripcion: "Pte. Firma",
          },
        ],
        registros: [],
      },
    },
  ],
};
export default {
  name: "Component-TablaFoliosFechas",
  data: (vm) => ({
    dialogNewDocumento: false,
    data: [],
    justify: ["start", "center", "end", "space-around", "space-between"],
    pageCount: null,
    page: 1,
    itemsPerPage: 5,
    loading: false,
    perfil: false,
    headers: [
      {
        text: "Folio",
        value: "idFolio",
        align: "center",
      },
      { text: "Documento", value: "documento.titulo", align: "center" },
      {
        text: "Unidad(es) de Negocio",
        value: "unidadesNegocio",
        align: "center",
      },
      { text: "Documentador", value: "creador.nombre", align: "center" },
      { text: "Estado", value: "estado.descripcion", align: "center" },
      {
        text: "Última Firma",
        value: "firmas.ultima.empleado.nombre",
        align: "center",
      },
      {
        text: "Pte. Firma",
        value: "firmas.pendientes",
        width: 250,
        align: "center",
      },
      { text: "Acciones", value: "acciones", align: "center", sortable: false },
    ],
    dateStartFormatted: vm.formatDate(new Date().toISOString().substr(0, 10)),
    dateEndFormatted: vm.formatDate(new Date().toISOString().substr(0, 10)),
    menuFechaInicio: false,
    menuFechaFin: false,
    fechaInicio: new Date().toISOString().substr(0, 10),
    fechaFin: new Date().toISOString().substr(0, 10),
    dataSelected: [],
    dataSelectedToExport: JSON.parse(JSON.stringify(excelPlantilla)),
    dataToExport: JSON.parse(JSON.stringify(excelPlantilla)),
    idFolioCloned: null,
  }),
  watch: {
    fechaInicio: function (val) {
      this.dateStartFormatted = this.formatDate(val);
    },
    fechaFin: function (val) {
      this.dateEndFormatted = this.formatDate(val);
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    obtienePerfil() {
      let user = serviceLocalStorage.userToken();
      this.perfil = false;

      store.state.perfiles.forEach((item) => {
        if (item.perfil.id_perfil == 338) {
          this.perfil = true;
        }
      });

      var usuariosFranquicia = [
        "73610",
        "189140",
        "331952",
        "189871",
        "73606",
        "165943",
      ];
      usuariosFranquicia.forEach((currentValue, index, array) => {
        if (user.empleado == usuariosFranquicia[index]) {
          this.perfil = true;
        }
      });
    },
    prepareItemsForExport(data) {
      let dataReturn = [];
      data.forEach((item) => {
        let unidadesNegocio = "";
        if (item.unidadesNegocio) {
          item.unidadesNegocio.forEach(
            (itemUnidadNegocio, indexUnidadNegocio) => {
              unidadesNegocio += itemUnidadNegocio.descripcion;
              if (indexUnidadNegocio < item.unidadesNegocio.length - 1) {
                unidadesNegocio += ", ";
              }
            }
          );
        }
        let firmasPendientes = "";
        if (item.firmas.pendientes) {
          item.firmas.pendientes.forEach((itemFirma, indexFirma) => {
            firmasPendientes += itemFirma.empleado.nombre;
            if (indexFirma < item.firmas.pendientes.length - 1) {
              firmasPendientes += ", ";
            }
          });
        }
        const row = {
          idFolio: item.idFolio,
          "documento.titulo": item.documento.titulo,
          unidadesNegocio,
          "creador.nombre": item.creador.nombre,
          "estado.descripcion": item.estado.descripcion,
          "firmas.ultima.empleado.nombre": item.firmas.ultima.empleado
            ? item.firmas.ultima.empleado.nombre
            : "N/A",
          "firmas.pendientes": firmasPendientes,
        };
        dataReturn.push(row);
      });
      return dataReturn;
    },
    selectedItems(event) {
      this.dataSelected = event;
      let registros = this.prepareItemsForExport(event);
      this.dataSelectedToExport.hojas[0].contenido.registros = registros;
    },
    formatDate(date) {
      return moment(date).format("DD-MM-YYYY");
    },
    to(folio) {
      return {
        name: "modelo_negocio_documentos_visualizar_resumen_folio",
        query: {
          back: serviceCommons.objectToBase64({
            name: "modelo_negocio_documentos_estados",
          }),
        },
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folio.idFolio,
          }),
        },
      };
    },
    classEstado(idEstadoFolio) {
      if (idEstadoFolio == 2) {
        return { "documentar--text": true };
      }
      if (idEstadoFolio == 3) {
        return { "revisar--text": true };
      }
      if (idEstadoFolio == 4) {
        return { "autorizar--text": true };
      }
      if (idEstadoFolio == 5) {
        return { "publicado--text": true };
      }
    },
    putFolioDuplicar(folio) {
      axios
        .post("/modelo-negocio/folios/v1/" + folio.idFolio + "/duplica-folio")
        .then((response) => {
          let data = response.data;
          if (data) {
            this.idFolioCloned = data.resultado.id;
          }
          this.dialogNewDocumento = true;
          this.getFoliosEstadosBusquedas();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },

    putFolioEstados(folio, estado) {
      let body = {
        idEstadoFolio: estado,
      };
      axios
        .put("/modelo-negocio/folios/v1/" + folio.idFolio + "/estados", body)
        .then((response) => {
          this.getFoliosEstadosBusquedas();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteFolio(folio) {
      axios
        .delete("/modelo-negocio/folios/v1/" + folio.idFolio)
        .then((response) => {
          this.getFoliosEstadosBusquedas();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    editarRutasFolio(folio) {
      return {
        name: "modelo_negocio_documentos_edicion",
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folio.idFolio,
            indicePaso: 2,
          }),
        },
      };
    },
    editarFolio(folio) {
      return {
        name: "modelo_negocio_documentos_edicion",
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folio.idFolio,
            indicePaso: 1,
          }),
        },
      };
    },
    exportToExcel(data) {
      axios({
        method: "post",
        url: "/utilerias/archivos/convertir/json/excel/plantilla",
        responseType: "blob",
        data: data,
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getFoliosEstadosBusquedas() {
      const self = this;
      let body = {
        fechaInicio: this.dateStartFormatted,
        fechaFin: this.dateEndFormatted,
      };
      this.loading = true;
      axios
        .post("/modelo-negocio/folios/v1/busquedas/fechas", body)
        .then((response) => {
          let data = response.data;
          if (data) {
            self.data = data.resultado.folios;
            let registros = self.prepareItemsForExport(self.data);
            self.dataToExport.nombre +=
              " " + body.fechaInicio + " a " + body.fechaFin;
            self.dataSelectedToExport.nombre +=
              " " + body.fechaInicio + " a " + body.fechaFin;
            self.dataToExport.hojas[0].contenido.registros = registros;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          self.loading = false;
        });
    },
  },
  created() {
    let date = new Date();
    date.setDate(1);
    this.dateStartFormatted = this.formatDate(date.toISOString().substr(0, 10));
    this.fechaInicio = date.toISOString().substr(0, 10);
    this.getFoliosEstadosBusquedas();
  },
  mounted() {
    this.obtienePerfil();
  },
};
</script>
